enum GlcdColor {_clClear, _clDraw, _clInvert};
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  char          Left;
  char          Top;
  char          Width;
  char          Height;
  char          Visible;
  char          Active;
  char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  char          PressColEnabled;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  char          Left;
  char          Top;
  char          Width;
  char          Height;
  char          *Caption;
  const char    *FontName;
  unsigned char Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  char          Left;
  char          Top;
  char          Width;
  char          Height;
  char          Visible;
  char          Active;
  char          Transparent;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

typedef struct  Line {
  TScreen*  OwnerScreen;
  char          Order;
  char          First_Point_X;
  char          First_Point_Y;
  char          Second_Point_X;
  char          Second_Point_Y;
  char          Visible;
} TLine;

struct Screen {
  unsigned short         ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
  unsigned int           LinesCount;
  TLine                 * const code *Lines;
};

extern   TScreen                Dialer;
extern   TBox                   Box1;
extern   TButton               Button1;
extern   TButton               Button2;
extern   TButton               Button3;
extern   TButton               Button4;
extern   TButton               Button5;
extern   TButton               Button6;
extern   TButton               Button7;
extern   TButton               Button8;
extern   TButton               Button9;
extern   TButton               Button10;
extern   TButton               btnPhone;
extern   TButton               btnDel;
extern   TButton               btnX;
extern   TLabel                 lblNumber;
extern   TButton               ButtonPlus;
extern   TButton                * const code Screen1_Buttons[14];
extern   TLabel                 * const code Screen1_Labels[1];
extern   TBox                   * const code Screen1_Boxes[1];


extern   TScreen                Phone;
extern   TButton               btnCall;
extern   TButton               btnEnd;
extern   TLine                  Line1;
extern   TLine                  Line2;
extern   TLine                  Line3;
extern   TLine                  Line4;
extern   TLine                  Line5;
extern   TButton               btnDialer;
extern   TLabel                 lblInfo;
extern   TLabel                 lblStatus;
extern   TLine                  Line6;
extern   TButton                * const code Screen2_Buttons[3];
extern   TLabel                 * const code Screen2_Labels[2];
extern   TLine                  * const code Screen2_Lines[6];



/////////////////////////
// Events Code Declarations
void btnCallOnClick();
void btnDelOnClick();
void btnDialerOnClick();
void btnEndOnClick();
void btnPhoneOnClick();
void btnXOnClick();
void Button10OnClick();
void Button1OnClick();
void Button2OnClick();
void Button3OnClick();
void Button4OnClick();
void Button5OnClick();
void Button6OnClick();
void Button7OnClick();
void Button8OnClick();
void Button9OnClick();
void ButtonPlusOnClick();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Box1_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char Button9_Caption[];
extern char Button10_Caption[];
extern char btnPhone_Caption[];
extern char btnDel_Caption[];
extern char btnX_Caption[];
extern char lblNumber_Caption[];
extern char ButtonPlus_Caption[];
extern char btnCall_Caption[];
extern char btnEnd_Caption[];
extern char Line1_Caption[];
extern char Line2_Caption[];
extern char Line3_Caption[];
extern char Line4_Caption[];
extern char Line5_Caption[];
extern char btnDialer_Caption[];
extern char lblInfo_Caption[];
extern char lblStatus_Caption[];
extern char Line6_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawBox(TBox *ABox);
void DrawLine(TLine *Aline);
void Check_TP();
void Start_TP();
